#include <bits/stdc++.h>
using namespace std;
using ull=unsigned long long;
ull getNext(ull pr1, ull pr2){
    vector<int> d;
    ull z=pr1*pr2, z1=0;
    if(z==0) z1=9;
    else{
        while(z){
            int digit;
            if(z%10>0) digit=(z%10-1);
            else digit=9;
            d.push_back(digit);
            z/=10;
        }
        for(int i=d.size()-1; i>=0; i--) z1=z1*10+d[i];
    }
    return z1%1000;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    ull n, a, b;
    cin>>n>>a>>b;
    ull i=2;
    bool printA=0;
    while(i<n){
        if(i%2==0) {
            a=getNext(a, b);
            printA=1;
        }
        else {
            b=getNext(a, b);
            printA=0;
        }
        i++;
    }
    if(printA) cout<<a<<"\n";
    else cout<<b<<"\n";
    return 0;
}
